import axios from 'axios';
import store from '../store/index';
import router from '@/router';
import { authDataAction } from '../store/authData';
const instance = axios.create({
  baseURL: process.env.VUE_APP_API_BASE_URL
});

instance.interceptors.request.use(config => {
  const authJWT = store.state.authData.authJWT;
  if (authJWT) {
    config.headers.Authorization = 'Bearer ' + authJWT;
  }
  return config;
});
instance.interceptors.response.use(
  config => {
    // console.log(config);
    return config; //.data;
  },
  error => {
    if (error.response && (error.response.status === 401 || error.response.status === 403)) {
      store.dispatch(authDataAction.Logout);
    }
    return Promise.reject(error);
  }
);
export { instance };
