import Vue from 'vue';
import App from './App.vue';
import router from './router';
import store from './store';
import vuetify from './plugins/vuetify';
import moment from 'moment';

import DatetimePicker from 'vuetify-datetime-picker';
// (Optional) import 'vuetify-datetime-picker/src/stylus/main.styl'
Vue.use(DatetimePicker);

Vue.config.productionTip = false;

router.beforeEach((to, from, next) => {
  // document.title = to.meta.title;
  const isLogin = localStorage.getItem('authJWT') ? true : false;
  if (isLogin) {
    if (to.path === '/login') {
      next('/home');
    } else if (to.path === '/') {
      next('/home');
    } else {
      const page = router.options.routes.find(link => link.path === to.path);
      if (page) {
        const havePermission = JSON.parse(atob(localStorage.getItem('authJWT').split('.')[1])).level >= page.level;
        if (havePermission) {
          next();
        } else {
          alert('沒有權限進入該頁面');
          next('/home');
        }
      } else {
        next(from.path);
      }
      next();
    }
  } else {
    if (to.path === '/login') {
      next();
    } else {
      localStorage.setItem('lastUrl', to.fullPath);
      // this.$router.push({ name: 'login', query: { redirect: '/path' } });
      next({
        path: '/login',
        query: {
          nextUrl: to.fullPath
        }
      });
    }
  }
});

Vue.filter('formatDateTime', value => {
  if (value) {
    return moment(String(value)).format('YYYY/MM/DD HH:mm:ss');
  }
});
Vue.filter('formatDate', value => {
  if (value) {
    return moment(String(value)).format('YYYY/MM/DD');
  }
});

new Vue({
  router,
  store,
  vuetify,
  render: h => h(App)
}).$mount('#app');
