import Vue from 'vue';
import VueRouter from 'vue-router';
import Home from '../views/Home.vue';
import Login from '../views/Login.vue';

Vue.use(VueRouter);
const routes = [
  {
    path: '/login',
    name: 'login',
    component: Login
  },
  {
    path: '/home',
    name: 'home',
    component: Home,
    isMenu: true,
    icon: 'mdi-home',
    admin: false,
    props: { title: 'Home' },
    level: 0
  },
  {
    path: '/PageA',
    name: 'PageA',
    component: () => import(/* webpackChunkName: "PageA" */ '../views/PageA.vue'),
    isMenu: true,
    icon: 'mdi-home',
    admin: true,
    props: { title: 'PageA' },
    level: 0
  },
  {
    path: '/PageB',
    name: 'PageB',
    component: () => import(/* webpackChunkName: "PageB" */ '../views/PageB.vue'),
    isMenu: true,
    icon: 'mdi-home',
    admin: true,
    props: { title: 'PageB' },
    level: 20
  },
  {
    path: '/PageC',
    name: 'PageC',
    component: () => import(/* webpackChunkName: "PageC" */ '../views/PageC.vue'),
    isMenu: true,
    icon: 'mdi-home',
    admin: true,
    props: { title: 'PageC' },
    level: 50
  },
  {
    path: '*',
    component: () => import(/* webpackChunkName: "login" */ '../views/Login.vue'),
    isMenu: false,
    props: { title: '登入' }
  }
];

const router = new VueRouter({
  mode: 'history',
  routes
});

export default router;
