import Vue from 'vue';
import Vuex from 'vuex';
import { pagesData } from './pagesData';
import { authData } from './authData';
Vue.use(Vuex);

export default new Vuex.Store({
  state: {
    snackbar: {
      visible: false,
      message: '',
      color: 'error',
    },
  },
  mutations: {
    showSuccessSnackBar(state, payload) {
      state.snackbar.message = payload;
      state.snackbar.color = 'success';
      state.snackbar.visible = true;
      setTimeout(() => {
        state.snackbar.visible = false;
      }, 3000);
    },
    showInfoSnackBar(state, payload) {
      state.snackbar.message = payload;
      state.snackbar.color = 'info';
      state.snackbar.visible = true;
      setTimeout(() => {
        state.snackbar.visible = false;
      }, 3000);
    },
    showErrorSnackBar(state, payload) {
      state.snackbar.message = payload;
      state.snackbar.color = 'error';
      state.snackbar.visible = true;
      setTimeout(() => {
        state.snackbar.visible = false;
      }, 3000);
    },
  },
  actions: {},
  modules: {
    pagesData,
    authData,
  },
});
