﻿using JWTVueDemo.Const;
using JWTVueDemo.Models;
using JWTVueDemo.Models.RequestModel;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Options;
using Microsoft.IdentityModel.Tokens;
using System;
using System.Collections.Generic;
using System.IdentityModel.Tokens.Jwt;
using System.Linq;
using System.Security.Claims;
using System.Text;
using System.Threading.Tasks;

namespace JWTVueDemo.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class AuthController : BaseController
    {
        public AuthController(IOptions<ApplicationSettings> appSettings) : base(appSettings)
        {
        }
        [HttpPost("[action]")]
        public BaseResponse<string> Login(LoginRequestModel loginInfo)
        {
            BaseResponse<string> response = new BaseResponse<string>
            {
                Data = "",
                Msg = "",
                Success = true
            };
            List<Claim> claims;
            if (loginInfo.Account.Equals("admin") && loginInfo.Password.Equals("123"))
            {
                claims = new List<Claim>()
                {
                    new Claim("UserId","admin"),
                    new Claim("roles",Roles.Admin),
                    new Claim("level","100"),
                };
            }
            else if (loginInfo.Account.Equals("useradmin") && loginInfo.Password.Equals("123"))
            {
                claims = new List<Claim>()
                {
                    new Claim("UserId","admin"),
                    new Claim("roles",Roles.User),
                    new Claim("level","40"),
                };
            }
            else if (loginInfo.Account.Equals("user") && loginInfo.Password.Equals("123"))
            {
                claims = new List<Claim>()
                {
                    new Claim("UserId","admin"),
                    new Claim("roles",Roles.User),
                    new Claim("level","0"),
                };
            }
            else
            {
                response.Success = false;
                response.Msg = "帳號密碼錯誤";
                return response;
            }
            var key = new SymmetricSecurityKey(Encoding.UTF8.GetBytes(AppSettings.JWTSecret));
            var tokenDescriptor = new SecurityTokenDescriptor
            {
                Subject = new ClaimsIdentity(claims),
                Expires = DateTime.UtcNow.AddDays(30),
                SigningCredentials = new SigningCredentials(key, SecurityAlgorithms.HmacSha256Signature)
            };
            var tokenHandler = new JwtSecurityTokenHandler();
            var securityToken = tokenHandler.CreateToken(tokenDescriptor);
            var token = tokenHandler.WriteToken(securityToken);
            response.Data = token;
            return response;
        }
        [HttpGet("[action]")]
        public BaseResponse<DateTime> Test()
        {
            return new BaseResponse<DateTime>
            {
                Data = DateTime.Now,
                Msg = "Test",
                Success = true
            };
        }
        [Authorize(Roles = Roles.Admin)]
        [HttpGet("[action]")]
        public BaseResponse<DateTime> TestAdmin()
        {
            return new BaseResponse<DateTime>
            {
                Data = DateTime.Now,
                Msg = "TestAdmin",
                Success = true
            };
        }
        [Authorize(Roles = Roles.User)]
        [HttpGet("[action]")]
        public BaseResponse<DateTime> TestUser()
        {
            return new BaseResponse<DateTime>
            {
                Data = DateTime.Now,
                Msg = "TestUser",
                Success = true
            };
        }
        [Authorize(Roles = Roles.AdminAndUser)]
        [HttpGet("[action]")]
        public BaseResponse<DateTime> TestAdminAndUser()
        {
            return new BaseResponse<DateTime>
            {
                Data = DateTime.Now,
                Msg = "TestAdminAndUser",
                Success = true
            };
        }
    }
}
