﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace JWTVueDemo.Models
{
    public class BaseResponse
    {
        public BaseResponse()
        {
            Success = false;
            Msg = string.Empty;
        }
        public BaseResponse(bool success)
        {
            Success = success;
            Msg = string.Empty;
        }
        public BaseResponse(bool success, string msg)
        {
            Success = success;
            Msg = msg;
        }
        public bool Success { get; set; }
        public string Msg { get; set; }
    }
    public class BaseResponse<T> : BaseResponse
    {
        public BaseResponse()
        {
            Success = false;
            Msg = string.Empty;
            Data = default;
        }
        public BaseResponse(bool success, string msg, T data) : base(success, msg)
        {
            Data = data;
        }
        public T Data { get; set; }
    }
}
